datablock AudioProfile(SMGFireSound)
{
   filename    = "./fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(SMGMagInSound)
{
   filename    = "./clipIn.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(SMGMagOutSound)
{
   filename    = "./clipOut.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(SMGUseSound)
{
   filename    = "./use.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(SMGMagIn_emptySound)
{
   filename    = "./clipIn_e.wav";
   description = AudioClose3d;
   preload = true;
};

//shell
datablock DebrisData(SMGCasing)
{
	shapeFile = "./Shell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

//Effects
//Flash
datablock ParticleData(SMGflashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "./Flash";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 1.0;
	sizes[1]      = 1.5;

	useInvAlpha = false;
};
datablock ParticleEmitterData(SMGflashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 25;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SMGflashParticle";

   uiName = "SMG Flash";
};


AddDamageType("SMG",   '<bitmap:add-ons/Weapon_Fallout_Bundle/10MM_SMG/CI_SMG> %1',    '%2 <bitmap:add-ons/Weapon_Fallout_Bundle/10MM_SMG/CI_SMG> %1',0.2,1);
datablock ProjectileData(SMGProjectile)
{
   projectileShapeName = "./Bullet.dts";
   directDamage        = 20;
   directDamageType    = $DamageType::SMG;
   radiusDamageType    = $DamageType::SMG;

   brickExplosionRadius = 2;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 1;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 25;
   verticalImpulse	  = 0;
   explosion           = gunExplosion;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.2;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.5 0.5 0";

   uiName = "SMG Bullet";
};

//////////
// item //
//////////
datablock ItemData(SMGItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./10MMSMG_Ground.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "10MM SMG";
	iconName = "./UI_10MMSMG";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = SMGImage;
	canDrop = true;

	maxAmmo = 30;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(SMGImage)
{
   // Basic Item properties
   shapeFile = "./10MMSMG.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0.1 0";
   eyeOffset = "0.4 1.3 -0.25"; //"0.7 1.2 -0.5"; -Left +Right, -Back +Front, -Down +Up
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = SMGItem;
   ammo = " ";
   projectile = SMGProjectile;
   projectileType = Projectile;

	casing = SMGCasing;
	shellExitDir        = "2.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 25.0;	
	shellVelocity       = 10.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = SMGItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateSequence[0] = "use";
	stateTransitionOnTimeout[0]       = "LoadCheckA";
	stateSound[0]					= SMGUseSound;

	stateName[1]                     = "Ready";
	stateTransitionOnNoAmmo[1]       = "Reload";
	stateTransitionOnTriggerDown[1]  = "preFire";
	stateAllowImageChange[1]         = true;
	
	stateName[19]="preFire";
	stateTimeoutValue[19]=0;
	stateTransitionOnTimeout[19]="preFire2";
	stateScript[19]                  = "onFire";
	stateEmitter[19]					= SMGflashEmitter;
	stateEmitterTime[19]				= 0.03;
	stateEmitterNode[19]				= "muzzleNode";
	stateEjectShell[19]       	  = true;
	stateFire[19]                    = true;
	
	stateName[21]="preFire2";
	stateTransitionOnTimeout[21]="preFire3";
	stateScript[21]				= "onLoadCheck";
	
	stateName[20]="preFire3";
	stateTransitionOnNoAmmo[20]="Fire2";
	stateTransitionOnAmmo[20]="Fire";
	
	stateName[18]="Ready2";
	stateTransitionOnTriggerUp[18]="Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Delay";
	stateTimeoutValue[2]            = 0.00;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateWaitForTimeout[2]			= true;
	stateSound[2]					= SMGFireSound;
	
	stateName[16]                    = "Fire2";
	stateTransitionOnTimeout[16]     = "Delay";
	stateTimeoutValue[16]            = 0.00;
	stateAllowImageChange[16]        = false;
	stateSequence[16]                = "Fire";
	stateWaitForTimeout[16]			= true;
	stateSound[16]					= SMGFireSound;

	stateName[3]			= "Delay";
	stateEmitterTime[3]				= 0.05;
	stateEmitter[3]					= SMGSmokeEmitter;
	stateEmitterNode[3]				= "muzzleNode";
	stateTransitionOnTimeout[3]     = "FireLoadCheckA";
	stateTimeoutValue[3]            = 0.06;
	
	stateName[4]				= "LoadCheckA";
	stateScript[4]				= "onLoadCheck";
	stateTimeoutValue[4]			= 0.01;
	stateTransitionOnTimeout[4]		= "LoadCheckB";
	
	stateName[5]				= "LoadCheckB";
	stateTransitionOnAmmo[5]		= "Ready2";
	stateTransitionOnNoAmmo[5]		= "ReloadE";

	stateName[6]				= "Reload";
	stateTimeoutValue[6]			= 0.75;
	stateScript[6]				= "onReloadStart";
	stateTransitionOnTimeout[6]		= "Wait";
	stateWaitForTimeout[6]			= true;
	stateSequence[6]			= "clipOut";
	stateSound[6]				= SMGMagOutSound;
	
	stateName[7]				= "Wait";
	stateTimeoutValue[7]			= 0.85;
	stateSound[7]				= SMGMagInSound;
	stateSequence[7]			= "clipIn";
	stateTransitionOnTimeout[7]		= "Reloaded";
	
	stateName[8]				= "FireLoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "FireLoadCheckB";
	
	stateName[9]				= "FireLoadCheckB";
	stateTransitionOnAmmo[9]		= "Smoke";
	stateTransitionOnNoAmmo[9]		= "ReloadSmoke";
	
	stateName[10] 				= "Smoke";
	//stateTimeoutValue[10]			= 0.2;
	stateTransitionOnTimeout[10]		= "Ready2";
	stateTransitionOnTriggerDown[10]	= "preFire";
	
	stateName[11] 				= "ReloadSmoke";
	stateTimeoutValue[11]			= 0.2;
	stateTransitionOnTimeout[11]		= "ReloadE";
	
	stateName[12]				= "Reloaded";
	stateTimeoutValue[12]			= 0.01;
	stateScript[12]				= "onReloaded";
	stateTransitionOnTimeout[12]		= "Ready";
	
//empty reload states
	stateName[24]				= "ReloadE";
	stateTimeoutValue[24]			= 0.75;
	stateScript[24]				= "onReloadStart";
	stateTransitionOnTimeout[24]		= "WaitE";
	stateWaitForTimeout[24]			= true;
	stateSequence[24]			= "clipOut";
	stateSound[24]				= SMGMagOutSound;
	
	stateName[22]				= "WaitE";
	stateTimeoutValue[22]			= 1.35;
	stateSound[22]				= SMGMagIn_emptySound;
	stateSequence[22]			= "clipIn_e";
	stateTransitionOnTimeout[22]		= "Reloaded";
	
	stateName[23]				= "ReloadedE";
	stateTimeoutValue[23]			= 0.01;
	stateScript[23]				= "onReloaded";
	stateTransitionOnTimeout[23]		= "Ready";
};

datablock ShapeBaseImageData(SMGSightsImage)
{
   shapeFile = "./10MMSMGS.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0.1 0";
   eyeOffset = "0.0 1 -0.14"; //-Left +Right, -Back +Front, -Down +Up
   rotation = eulerToMatrix( "0 0 -0.4" );

   correctMuzzleVector = true;

   className = "WeaponImage";

   item = SMGItem;
   ammo = " ";
   projectile = SMGProjectile;
   projectileType = Projectile;

	casing = SMGCasing;
	shellExitDir        = "2.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 25.0;	
	shellVelocity       = 10.0;

   melee = false;
   armReady = true;

   doColorShift = true;
   colorShiftColor = SMGItem.colorShiftColor;//"0.400 0.196 0 1.000";
   
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.0001;
	stateTransitionOnTimeout[0]     = "LoadCheckA";

	stateName[1]                     = "Ready";
	stateTransitionOnNoAmmo[1]       = "Reload";
	stateTransitionOnTriggerDown[1]  = "preFire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]			  = "ready";
	
	stateName[19]="preFire";
	stateTimeoutValue[19]=0;
	stateTransitionOnTimeout[19]="preFire2";
	stateScript[19]                  = "onFire";
	stateEmitter[19]					= SMGFlashEmitter;
	stateEmitterTime[19]				= 0.03;
	stateEmitterNode[19]				= "muzzleNode";
	stateEjectShell[19]       	  = true;
	stateFire[19]                    = true;
	
	stateName[21]="preFire2";
	stateTransitionOnTimeout[21]="preFire3";
	stateScript[21]				= "onLoadCheck";
	
	stateName[20]="preFire3";
	stateTransitionOnNoAmmo[20]="Fire2";
	stateTransitionOnAmmo[20]="Fire";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Delay";
	stateTimeoutValue[2]            = 0.00;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateWaitForTimeout[2]			= true;
	stateSound[2]					= SMGFireSound;
	
	stateName[16]                    = "Fire2";
	stateTransitionOnTimeout[16]     = "Delay";
	stateTimeoutValue[16]            = 0.00;
	stateAllowImageChange[16]        = false;
	stateSequence[16]                = "Fire";
	stateWaitForTimeout[16]			= true;
	stateSound[16]					= SMGFireSound;

	stateName[3]				= "Delay";
	stateTransitionOnTimeout[3]     	= "FireLoadCheckA";
	stateTimeoutValue[3]            	= 0.06;
	
	stateName[4]				= "LoadCheckA";
	stateScript[4]				= "onLoadCheck";
	stateTimeoutValue[4]			= 0.02;
	stateTransitionOnTimeout[4]		= "LoadCheckB";
	
	stateName[5]				= "LoadCheckB";
	stateTransitionOnAmmo[5]		= "Ready";
	stateTransitionOnNoAmmo[5]		= "ReloadWait";
	
	stateName[6]				= "ReloadWait";
	stateTimeoutValue[6]			= 0.3;
	stateScript[6]				= "";
	stateTransitionOnTimeout[6]		= "reloadSequence";
	stateWaitForTimeout[6]			= true;
	
	stateName[7]				= "reloadSequence";
	stateScript[7]				= "setSMGReN";
	
	stateName[9]				= "FireLoadCheckA";
	stateScript[9]				= "onLoadCheck";
	stateTimeoutValue[9]			= 0.02;
	stateTransitionOnTimeout[9]		= "FireLoadCheckB";
	
	stateName[10]				= "FireLoadCheckB";
	stateTransitionOnAmmo[10]		= "Ready";
	stateTransitionOnNoAmmo[10]		= "ReloadWait";
};


function SMGImage::onFire(%this,%obj,%slot)
{
	%projectile = SMGProjectile;

	if(vectorLen(%obj.getVelocity()) < 0.1)
	{
		%spread = 0.002;
	}
	else
	{
		%spread = 0.002;
	}
	
	%obj.lastShotTime = getSimTime();
	%shellcount = 1;

	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

function SMGSightsImage::onFire(%this,%obj,%slot)
{ 
	%projectile = SMGProjectile;

	if(vectorLen(%obj.getVelocity()) < 0.1)
	{
		%spread = 0.001;
	}
	else
	{
		%spread = 0.002;
	}
	
	%obj.lastShotTime = getSimTime();
	%shellcount = 1;

	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

function SMGSightsImage::setSMGReN(%this,%obj,%slot)
{
	%obj.mountImage(SMGImage, 0, 0, 0);
	%obj.toolAmmo[%obj.currTool] = 0;
}

function SMGSightsImage::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <= 0)
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function SMGImage::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <= 0)
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function SMGImage::onReloadStart(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = 0;
}

function SMGImage::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
	%obj.AmmoSpent[%obj.currTool] = 0;
	%obj.setImageAmmo(%slot,1);
}

package SMGSightsSwitch
{
	function armor::onTrigger(%this, %obj, %triggerNum, %val)
	{
		%client = %obj.client;
		if(%triggerNum == 4 && %obj.isImageMounted(SMGImage) && %val && %obj.toolAmmo[%obj.currTool] != 0)
		{
			%newAmmo = %obj.toolAmmo[%obj.currTool];
			%obj.mountImage(SMGSightsImage, 0);
			%obj.toolAmmo[%obj.currTool] = %newAmmo;
		}
		else if(%triggerNum == 4 && %obj.isImageMounted(SMGSightsImage) && %val)
		{
			%newAmmo = %obj.toolAmmo[%obj.currTool];
			%obj.mountImage(SMGImage, 0);
			%obj.toolAmmo[%obj.currTool] = %newAmmo;
		}

		Parent::onTrigger(%this, %obj, %triggerNum, %val);
	}
};
activatePackage(SMGSightsSwitch);

function SMGImage::onMount(%this,%obj,%slot)
{
  
  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function SMGImage::onUnMount(%this,%obj,%slot)
{
  
  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
}

function SMGSightsImage::onMount(%this,%obj,%slot)
{
  
  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function SMGSightsImage::onUnMount(%this,%obj,%slot)
{
  
  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
}