datablock AudioProfile(FatManFireSound)
{
   filename    = "./fire.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(FatManclipInSound)
{
   filename    = "./clipIn.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(FatManUseSound)
{
   filename    = "./use.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(FatManExplodeSound)
{
   filename    = "./impact.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(bombLoopSound)
{
   filename    = "./bombLoop.wav";
   description = AudioCloseLooping3d;
   preload = true;
};

exec("add-ons/weapon_rocket_launcher/weapon_rocket launcher.cs");

//Effects
//Flash

//bullet trail effects
datablock ParticleData(FatManTrailParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.15;
	constantAcceleration = 0.0;
	lifetimeMS           = 3000;
	lifetimeVarianceMS   = 805;
	textureName          = "./combinedSmoke";
	spinSpeed		= 10.0;
	spinRandomMin		= -150.0;
	spinRandomMax		= 150.0;
	colors[0]     = "1.0 1.0 1.0 0.2";
	colors[1]     = "0.50 0.50 0.50 0.15";
   colors[2]     = "0.20 0.20 0.20 0.05";
   colors[3]     = "0.0 0.0 0.0 0.0";

	sizes[0]      = 0.50;
	sizes[1]      = 0.25;
   sizes[2]      = 0.7;
 	sizes[3]      = 0.01;

   times[0] = 0.0;
   times[1] = 0.05;
   times[2] = 0.3;
   times[3] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(FatManTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 1;
   ejectionVelocity = 0.25;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "FatManTrailParticle";
};

//upper mushroom cloud
datablock ParticleData(FatManExplosionParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -1.5;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 9350;
	lifetimeVarianceMS   = 135;
	textureName          = "./combinedSmoke";
	spinSpeed		= 25.0;
	spinRandomMin		= -25.0;
	spinRandomMax		= 25.0;
	colors[0]     = "1 0.65 0.2 0.9"; //"0.1 0.1 0.1 1";
	colors[1]     = "0.4 0.2 0.1 0.6"; //"0.4 0.5 0.5 0.9";
	colors[2]     = "0.0 0.0 0.0 0.1"; //"0.2 0.1 0.1 0.0";
	sizes[0]      = 16;
	sizes[1]      = 19;
	sizes[2]      = 20;
	times[0] = 0.0;
	times[1] = 0.5;
	times[2] = 1.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(FatManExplosionEmitter)
{
	lifeTimeMS = 380;

   ejectionPeriodMS = 100; //1
   periodVarianceMS = 4; //0
   ejectionVelocity = 50; //50
   velocityVariance = 0; //1.0
   ejectionOffset   = 0.0; //0.0
   thetaMin         = 0; //0
   thetaMax         = 0; //0
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "FatManExplosionParticle";


   emitterNode = TenthEmitterNode;
};

//exploded debris :D
datablock DebrisData(FatManDebris)
{
   emitters = "FatManExplosionChunkEmitter";

	shapeFile = "./brickDebris.dts";
	lifetime = 5.0;
	minSpinSpeed = -500.0;
	maxSpinSpeed = 400.0;
	elasticity = 0.5;
	friction = 0.05;
	numBounces = 5;
	staticOnMaxBounce = false;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

//inner "stem"
datablock ParticleData(FatManExplosionRingParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -1.5;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 9350;
	lifetimeVarianceMS   = 135;
	textureName          = "./combinedSmoke";
	spinSpeed		= 25.0;
	spinRandomMin		= -25.0;
	spinRandomMax		= 25.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0.4 0.2 0.1 0.6";
	colors[2]     =  "0.0 0.0 0.0 0.1";
	sizes[0]      = 16;
	sizes[1]      = 19;
	sizes[2]      = 20;
	
	times[0] = 0.0;
	times[1] = 0.1;
	times[2] = 1.0;

	
	useInvAlpha = true;
};
datablock ParticleEmitterData(FatManExplosionRingEmitter)
{
	lifeTimeMS = 1080;

   ejectionPeriodMS = 100;
   periodVarianceMS = 4;
   ejectionVelocity = 10;
   velocityVariance = 0.0;
   ejectionOffset   = 0.20;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   
   particles = "FatManExplosionRingParticle";
};

datablock DebrisData(FatManBitsDebris)
{
   emitters = "FatManTrailEmitter";

	lifetime = 0.1;
	minSpinSpeed = -300.0;
	maxSpinSpeed = 300.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 0;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = false;

	gravModifier = 3;
};

//Actual mushroom cloud
datablock ParticleData(FatManMushroomCloudParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 5000;
	lifetimeVarianceMS   = 0;
	textureName          = "./mCloud";
	spinSpeed		= 0.0;
	spinRandomMin		= -0.0;
	spinRandomMax		= 0.0;
	colors[0]     = "1 1 1 0.0";
	colors[1]     = "1 1 1 0.9";
	colors[2]     = "1 1 1 0.0";
	
	sizes[0]      = 25.50;
	sizes[1]      = 90.75;
	sizes[2]      = 100.0;

	times[0]      = 0.0;
	times[1]      = 0.05;
	times[2]      = 1.0;

	useInvAlpha = false;
};


datablock ParticleEmitterData(FatManMushroomCloudEmitter)
{
	lifeTimeMS = 10;
	ejectionPeriodMS = 10;
	periodVarianceMS = 0;
	ejectionVelocity = 0.1;
	velocityVariance = 0.0;
	ejectionOffset   = 0;
	thetaMin         = 0;
	thetaMax         = 0;
	phiReferenceVel  = 0;
	phiVariance      = 0;
	overrideAdvance = false;
	orientParticles = true;

   particles = "FatManMushroomCloudParticle";

	uiName = "FatMan Mushroom Cloud";
};

datablock ExplosionData(FatManExplosion)
{
   //explosionShape = "";
   //explosionShape = "./mushroomCloudExplosionSphere.dts";
	soundProfile = FatManExplodeSound;

   debris = FatManDebris;
   debrisNum = 20;
   debrisNumVariance = 5;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 180;
   debrisVelocity = 120;
   debrisVelocityVariance = 60;
   lifeTimeMS = 850;

   particleEmitter = FatManExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = FatManExplosionRingEmitter;
   emitter[1] = FatManMushroomCloudEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 2.5;
   camShakeRadius = 20.0;

   // Dynamic light
   lightStartRadius = 60;
   lightEndRadius = 80;
   lightStartColor = "0.9 0.8 0.2 1";
   lightEndColor = "0.3 0.1 0.0 1";

   damageRadius = 25;
   radiusDamage = 6000;

   impulseRadius = 10;
   impulseForce = 54000;
};





AddDamageType("FatMan_Direct",   '<bitmap:add-ons/Weapon_Fallout_Bundle/Fat_Man/CI_FatMan> %1',    '%2 <bitmap:add-ons/Weapon_Fallout_Bundle/Fat_Man/CI_FatMan> %1',0.2,1);
AddDamageType("FatMan_Radius",   '<bitmap:add-ons/Weapon_Fallout_Bundle/Fat_Man/CI_FatMan_RAD> %1',    '%2 <bitmap:add-ons/Weapon_Fallout_Bundle/Fat_Man/CI_FatMan_RAD> %1',0.2,1);
datablock ProjectileData(FatManProjectile)
{
   projectileShapeName = "./fmMiniNuke.dts";
   directDamage        = 500;
   radiusDamage        = 250;
   directDamageType = $DamageType::FatManDirect;
   radiusDamageType = $DamageType::FatManRadius;
   impactImpulse	   = 1000;
   verticalImpulse	   = 1000;
   explosion           = FatManExplosion;
   particleEmitter     = FatManTrailEmitter;

   brickExplosionRadius = 30;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 70;             
   brickExplosionMaxVolume = 300;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 400;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   sound = bombLoopSound;

   muzzleVelocity      = 65;
   velInheritFactor    = 1.0;

   armingDelay         = 00;
   lifetime            = 100000;
   fadeDelay           = 4500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 7;

   hasLight    = false;
   lightRadius = 5.0;
   lightColor  = "1 0.5 0.0";

   uiName = "Mini Nuke";
};

//////////
// item //
//////////
datablock ItemData(FatManItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./FatMan_Ground.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Fat Man";
	iconName = "./UI_FatMan";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = FatManImage;
	canDrop = true;

	maxAmmo = 1;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(FatManImage)
{
   // Basic Item properties
   shapeFile = "./FatMan.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0.15 0 0";
   eyeOffset = "0.65 1.4 -0.05"; //"0.5 1.3 -0.3"; -Left +Right, -Back +Front, -Down +Up
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = FatManItem;
   ammo = " ";
   projectile = FatManProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = FatManItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 1;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	stateSound[0]				= FatManUseSound;
	stateSequence[0]			= "use";

	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateAllowImageChange[1]         	= true;

	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "fireActual";
	stateTimeoutValue[2]            	= 0.05;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "fire";
	stateEjectShell[2]       	  	= false;
	stateWaitForTimeout[2]			= true;
	stateSound[2]				= FatManFireSound;

	stateName[7]				= "Delay";
	stateTransitionOnTimeout[7]     	= "FireLoadCheckA";
	stateTimeoutValue[7]            	= 0.00000000000000000000000001;
	
	stateName[8]				= "LoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "LoadCheckB";
	
	stateName[9]				= "LoadCheckB";
	stateTransitionOnAmmo[9]		= "Ready";
	stateTransitionOnNoAmmo[9]		= "Reload";

	stateName[10]				= "Reload";
	stateTimeoutValue[10]			= 0.0000000001;
	stateScript[10]				= "onReloadStart";
	stateTransitionOnTimeout[10]		= "Wait";
	stateWaitForTimeout[10]			= false;
	
	stateName[11]				= "Wait";
	stateTimeoutValue[11]			= 2.05;
	stateSound[11]				= FatManclipInSound;
	stateScript[11]				= "onReloadWait";
	stateSequence[11]			= "clipIn";
	stateTransitionOnTimeout[11]		= "Reloaded";
	
	stateName[12]				= "FireLoadCheckA";
	stateScript[12]				= "onLoadCheck";
	stateTimeoutValue[12]			= 0.0000000000001;
	stateTransitionOnTimeout[12]		= "FireLoadCheckB";
	
	stateName[13]				= "FireLoadCheckB";
	stateTransitionOnAmmo[13]		= "Smoke";
	stateTransitionOnNoAmmo[13]		= "ReloadSmoke";
	
	stateName[14] 				= "Smoke";
	stateTimeoutValue[14]			= 0.00000000001;
	stateTransitionOnTimeout[14]		= "Ready";
	stateTransitionOnTriggerDown[14]	= "Fire";
	
	stateName[15] 				= "ReloadSmoke";
	stateTimeoutValue[15]			= 0.00000000000001;
	stateTransitionOnTimeout[15]		= "Reload";
	
	stateName[16]				= "Reloaded";
	stateTimeoutValue[16]			= 0.01;
	stateScript[16]				= "onReloaded";
	stateTransitionOnTimeout[16]		= "Ready";
	
	stateName[17]				= "fireActual";
	stateTimeoutValue[17]			= 0.00000000001;
	stateFire[17]                    	= true;
	stateScript[17]				= "onFire";
	stateTransitionOnTimeout[17]		= "Delay";
	stateAllowImageChange[17]        	= false;
	stateWaitForTimeout[17]			= false;
};

function FatManImage::onFire(%this,%obj,%slot)
{
	%projectile = FatManProjectile;

	if(vectorLen(%obj.getVelocity()) < 0.1)
	{
		%spread = 0;
	}
	else
	{
		%spread = 0;
	}
	
	%obj.lastShotTime = getSimTime();
	%shellcount = 1;

	//%obj.playThread(2, plant);
	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

function FatManImage::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <= 0)
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function FatManImage::onReloadStart(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = 0;
}

function FatManImage::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = 1;
	%obj.setImageAmmo(%slot,1);
}


function FatManImage::onMount(%this,%obj,%slot)
{
  
  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function FatManImage::onUnMount(%this,%obj,%slot)
{
  
  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
}
