datablock AudioProfile(Sniper_RifleFireSound)
{
   filename    = "./fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Sniper_RifleEchoSound)
{
   filename    = "./echo.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Sniper_RifleImpactSound)
{
   filename    = "./bulletImpact.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Sniper_RifleclipInSound)
{
   filename    = "./clipIn.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Sniper_RifleclipOutSound)
{
   filename    = "./clipOut.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Sniper_RifleUseSound)
{
   filename    = "./use.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Sniper_RifleclipOut_emptySound)
{
   filename    = "./clipOut_e.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Sniper_RifleclipIn_emptySound)
{
   filename    = "./clipIn_e.wav";
   description = AudioClose3d;
   preload = true;
};


//shell
datablock DebrisData(Sniper_RifleCasing)
{
	shapeFile = "./Shell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock ParticleData(Sniper_RifleTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 2;
	gravityCoefficient	= 0.01;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 3000;
	lifetimeVarianceMS	= 500;
	spinSpeed		= 0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;
	textureName		= "base/data/particles/dot";
	colors[0]     = "1 1 1 1";
	colors[1]     = "1 1 1 0";
	sizes[0]	= 0.2;
	sizes[1]	= 0.0;
	times[0]	= 0.0;
	times[1]	= 1.0;
};
datablock ParticleEmitterData(Sniper_RifleTrailEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = Sniper_RifleTrailParticle;

   useEmitterColors = true;
   uiName = "";
};

//Effects
//Flash
datablock ParticleData(Sniper_RifleflashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "./SniperFlash";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 2.0;
	sizes[1]      = 3.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(Sniper_RifleflashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 25;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Sniper_RifleflashParticle";

   uiName = "Sniper_Rifle Flash";
};

AddDamageType("Sniper_Rifle",   '<bitmap:add-ons/Weapon_Fallout_Bundle/Sniper_Rifle/CI_Sniper_Rifle> %1',    '%2 <bitmap:add-ons/Weapon_Fallout_Bundle/Sniper_Rifle/CI_Sniper_Rifle> %1',0.2,1);
datablock ProjectileData(Sniper_RifleTracerProjectile)
{
   projectileShapeName = "./Bullet.dts";
   directDamage        = 45;
   directDamageType    = $DamageType::Sniper_Rifle;
   radiusDamageType    = $DamageType::Sniper_Rifle;

   brickExplosionRadius = 2;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 5;
   brickExplosionMaxVolume = 10;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 15;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 25;
   verticalImpulse	  = 2;
   explosion           = gunExplosion;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 50;
   bounceFriction      = 0.01;
   isBallistic         = true;
   bounceAngle         = 0; 
   minStickVelocity    = 1000;
   bounceElasticity    = 1000;
   bounceFriction      = 0;
   gravityMod = 0;

   hasLight    = false;
   lightRadius = 5.0;
   lightColor  = "0.5 0.5 0";

   uiName = "Sniper_Rifle bullet";
};

//////////
// item //
//////////
datablock ItemData(Sniper_RifleItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Sniper_Rifle_Ground.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Sniper Rifle";
	iconName = "./UI_Sniper_Rifle";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = Sniper_RifleImage;
	canDrop = true;

	maxAmmo = 5;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(Sniper_RifleImage)
{

	raycastWeaponRange			= 1000;				
	raycastWeaponTargets		= ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
	raycastDirectDamage			= 50;
	raycastDirectDamageType		= $DamageType::Sniper_Rifle;		
	raycastExplosionProjectile	= Sniper_RifleTracerProjectile;			
	raycastExplosionSound		= Sniper_RifleImpactSound;


   // Basic Item properties
   shapeFile = "./Sniper_Rifle.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0.5 0";
   eyeOffset = "0.4 1.2 -0.4"; //0 -Left +Right, -Back +Front, -Down +Up
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = Sniper_RifleItem;
   ammo = " ";
   projectile = Sniper_RifleTracerProjectile;
   projectileType = Projectile;

	casing = Sniper_RifleCasing;
	shellExitDir        = "2.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 25.0;
	shellVelocity       = 10.0;


   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = Sniper_RifleItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   // Initial start up state
	
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.95;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	stateSound[0]				= Sniper_RifleUseSound;
	stateSequence[0]			= "use";

	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "preFire";
	stateAllowImageChange[1]         	= true;

	stateName[19]="preFire";
	stateTimeoutValue[19]			=0;
	stateTransitionOnTimeout[19]="preFire2";
	stateScript[19]                  = "onFire";
	stateEjectShell[19]       	  = true;
	stateEmitter[19]					= Sniper_RifleFlashEmitter;
	stateEmitterTime[19]				= 0.04;
	stateEmitterNode[19]				= "muzzleNode";
	stateFire[19]                    = true;
	
	stateName[21]="preFire2";
	stateTransitionOnTimeout[21]="preFire3";
	stateScript[21]				= "onLoadCheck";
	
	stateName[20]="preFire3";
	stateTransitionOnNoAmmo[20]="Fire2";
	stateTransitionOnAmmo[20]="Fire";
	
	stateName[18]="Ready2";
	stateTransitionOnTriggerUp[18]="Ready";
	
	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Delay";
	stateTimeoutValue[2]            = 0.00;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateWaitForTimeout[2]			= true;
	stateSound[2]				= Sniper_RifleFireSound;

	stateName[16]                    = "Fire2";
	stateTransitionOnTimeout[16]     = "Delay";
	stateTimeoutValue[16]            = 0.00;
	stateAllowImageChange[16]        = false;
	stateSequence[16]                = "Fire";
	stateWaitForTimeout[16]			= true;
	stateSound[16]				= Sniper_RifleFireSound;
	
	stateName[3]			= "Delay";
	stateTransitionOnTimeout[3]     = "FireLoadCheckA";
	stateTimeoutValue[3]            = 0.6;
	
	stateName[8]				= "LoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "LoadCheckB";
	
	stateName[9]				= "LoadCheckB";
	stateTransitionOnAmmo[9]		= "Ready2";
	stateTransitionOnNoAmmo[9]		= "ReloadE";

	stateName[10]				= "Reload";
	stateTimeoutValue[10]			= 0.98;
	stateScript[10]				= "onReloadStart";
	stateTransitionOnTimeout[10]		= "Wait";
	stateWaitForTimeout[10]			= true;
	stateSequence[10]			= "clipOut";
	stateSound[10]				= Sniper_RifleclipOutSound;
	
	stateName[11]				= "Wait";
	stateTimeoutValue[11]			= 1.00;
	stateSound[11]				= Sniper_RifleclipInSound;
	stateScript[11]				= "onReloadWait";
	stateSequence[11]			= "clipIn";
	stateTransitionOnTimeout[11]		= "Reloaded";
	
	stateName[12]				= "FireLoadCheckA";
	stateScript[12]				= "onLoadCheck";
	stateTimeoutValue[12]			= 0.01;
	stateTransitionOnTimeout[12]		= "FireLoadCheckB";
	
	stateName[13]				= "FireLoadCheckB";
	stateTransitionOnAmmo[13]		= "Smoke";
	stateTransitionOnNoAmmo[13]		= "ReloadSmoke";
	
	stateName[14] 				= "Smoke";
	stateTransitionOnTimeout[14]		= "Ready2";
	
	stateName[15] 				= "ReloadSmoke";
	stateTimeoutValue[15]			= 0.2;
	stateTransitionOnTimeout[15]		= "ReloadE";
	
	stateName[22]				= "Reloaded";
	stateTimeoutValue[22]			= 0.01;
	stateScript[22]				= "onReloaded";
	stateTransitionOnTimeout[22]		= "Ready";
	
	//empty reload states
	stateName[23]				= "ReloadE";
	stateTimeoutValue[23]			= 0.98;
	stateScript[23]				= "onReloadStart";
	stateTransitionOnTimeout[23]		= "WaitE";
	stateWaitForTimeout[23]			= true;
	stateSequence[23]			= "clipOut";
	stateSound[23]				= Sniper_RifleclipOutSound;
	
	stateName[24]				= "WaitE";
	stateTimeoutValue[24]			= 1.70;
	stateSound[24]				= Sniper_RifleclipIn_emptySound;
	stateScript[24]				= "onReloadWait";
	stateSequence[24]			= "clipIn_e";
	stateTransitionOnTimeout[24]		= "Reloaded";
};

datablock ShapeBaseImageData(Sniper_RifleSightsImage)
{

	raycastWeaponRange			= 1000;				
	raycastWeaponTargets		= ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
	raycastDirectDamage			= 50;
	raycastDirectDamageType		= $DamageType::Sniper_Rifle;		
	raycastExplosionProjectile	= Sniper_RifleTracerProjectile;			
	raycastExplosionSound		= Sniper_RifleImpactSound;


   // Basic Item properties
   shapeFile = "./Sniper_RifleS.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0.5 0";
   eyeOffset = "0.0 -0.08 -0.33"; //0 -Left +Right, -Back +Front, -Down +Up
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = Sniper_RifleItem;
   ammo = " ";
   projectile = Sniper_RifleTracerProjectile;
   projectileType = Projectile;

	casing = Sniper_RifleCasing;
	shellExitDir        = "-2.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 25.0;
	shellVelocity       = 10.0;


   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = Sniper_RifleItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   // Initial start up state
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.001;
	stateTransitionOnTimeout[0]     = "LoadCheckA";

	stateName[1]                    = "Ready";
	stateTransitionOnNoAmmo[1]	= "reloadSequence";
	stateTransitionOnTriggerDown[1]  	= "preFire";
	stateAllowImageChange[1]         	= true;
	stateSequence[2]                = "ready";

	stateName[19]="preFire";
	stateTimeoutValue[19]=0;
	stateTransitionOnTimeout[19]="preFire2";
	stateScript[19]                  = "onFire";
	stateEjectShell[19]       	  = true;
	stateEmitter[19]					= Sniper_RifleFlashEmitter;
	stateEmitterTime[19]				= 0.04;
	stateEmitterNode[19]				= "muzzleNode";
	stateFire[19]                    = true;
	
	stateName[21]="preFire2";
	stateTransitionOnTimeout[21]="preFire3";
	stateScript[21]				= "onLoadCheck";
	
	stateName[20]="preFire3";
	stateTransitionOnNoAmmo[20]="Fire2";
	stateTransitionOnAmmo[20]="Fire";
	
	stateName[18]="Ready2";
	stateTransitionOnTriggerUp[18]="Ready";
	
	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Delay";
	stateTimeoutValue[2]            = 0.00;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateWaitForTimeout[2]			= true;
	stateSound[2]				= Sniper_RifleFireSound;
	
	stateName[16]                    = "Fire2";
	stateTransitionOnTimeout[16]     = "Delay";
	stateTimeoutValue[16]            = 0.00;
	stateAllowImageChange[16]        = false;
	stateSequence[16]                = "Fire";
	stateWaitForTimeout[16]			= true;
	stateSound[16]				= Sniper_RifleFireSound;
	
	stateName[7]				= "Delay";
	stateTransitionOnTimeout[7]     	= "FireLoadCheckA";
	stateTimeoutValue[7]            	= 0.6;
	
	stateName[8]				= "LoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "LoadCheckB";
	
	stateName[9]				= "LoadCheckB";
	stateTransitionOnAmmo[9]		= "Ready";
	stateTransitionOnNoAmmo[9]		= "Empty";

	stateName[12]				= "FireLoadCheckA";
	stateScript[12]				= "onLoadCheck";
	stateTimeoutValue[12]			= 0.01;
	stateTransitionOnTimeout[12]		= "FireLoadCheckB";
	
	stateName[13]				= "FireLoadCheckB";
	stateTransitionOnAmmo[13]		= "Smoke";
	stateTransitionOnNoAmmo[13]		= "Empty";
	
	stateName[14] 				= "Smoke";
	stateEmitter[14]			= gunSmokeEmitter;
	stateEmitterTime[14]			= 0.05;
	stateEmitterNode[14]			= "muzzleNode";
	stateTimeoutValue[14]			= 0.05;
	stateTransitionOnTimeout[14]		= "Ready";
	stateTransitionOnTriggerDown[14]	= "Fire";
	
	stateName[15]				= "Empty";
	stateTransitionOnTimeout[15]     	= "EmptyCheck";
	stateTimeoutValue[15]            	= 0.01;
	
	stateName[3]				= "EmptyCheck";
	stateTransitionOnOnTriggerDown[3]		= "EmptyClick";
	
	stateName[17]				= "EmptyClick";
//	stateSound[17]				= AMW_HawkeyeDryfireSound;
	stateTransitionOnTimeout[17]     	= "EmptyCheck";
	stateTimeoutValue[17]            	= 0.01;		
};

function Sniper_RifleImage::onFire(%this,%obj,%slot)
	{
	
	%obj.PlayAudio(2,Sniper_RifleEchoSound);
	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;
	
	if(%this.raycastWeaponRange > 0)
	{
		// Directional Math
		%fvec		= %obj.getForwardVector();
		%fX			= getWord(%fvec,0);
		%fY			= getWord(%fvec,1);
		
		%evec		= %obj.getEyeVector();
		%eX			= getWord(%evec,0);
		%eY			= getWord(%evec,1);
		%eZ			= getWord(%evec,2);
		
		%eXY		= mSqrt((%eX * %eX) + (%eY * %eY));
		%aimVec		= (%fX * %eXY) SPC (%fY * %eXY) SPC %eZ;
		
		// Range
		%range		= %this.raycastWeaponRange * getWord(%obj.getScale(), 2);
		
		if(%range >= 100)
		{
			%rangeRem = %range - 100;
			%range = 100;
		}
		
		// Raycast Parameters
		%start		= %obj.getEyePoint();
		%end[0]		= vectorAdd(%start, vectorScale(%aimVec, %range)); // [0] required for loop
		%targets	= %this.raycastWeaponTargets;
		
		// Raycasting
		%ray		= ContainerRayCast(%start, %end[0], %targets, %obj);
		%col		= getWord(%ray, 0);
		
		if(isObject(%col))
		{
			%pos	= posFromRaycast(%ray);
			%normal	= normalFromRaycast(%ray);
			%end[0]	= %pos;
			%colclass	= %col.getClassName();
			%objsHit++;
			
			%this.onHitObject(%obj, %slot, %col, %pos, %normal, %objsHit);
			
			if(%colclass $= "Player" || %colclass $= "AIPlayer")
			{
				if(%col.getState() $= "Dead")
				{
					%objsKilled++;
				}
			}
		}
		
		if(%rangeRem > 0)
		{
			for(%a = 1; %a <= 10 && %rangeRem > 0; %a++)
			{
				%range		= %rangeRem;
				
				if(%range >= 100)
				{
					%rangeRem = %range - 100;
					%range = 100;
				}
				
				%start[%a]	= %end[%a - 1];
				%end[%a]	= vectorAdd(%start[%a], vectorScale(%aimVec, %range)); 
				
				%ray		= ContainerRayCast(%start[%a], %end[%a], %targets, %obj);
				%col		= getWord(%ray, 0);
				
				if(isObject(%col))
				{
					%pos		= posFromRaycast(%ray);
					%normal		= normalFromRaycast(%ray);
					%end[%a]	= %pos;
					%colclass	= %col.getClassName();
					%objsHit++;
					
					%this.onHitObject(%obj, %slot, %col, %pos, %normal, %objsHit);
					
					if(%colclass $= "Player" || %colclass $= "AIPlayer")
					{
						if(%col.getState() $= "Dead")
						{
							%objsKilled++;
						}
					}
					
					if(%objsHit >= 4)
					{
						break;
					}
				}
			}
		}
		
		if(%objsKilled >= 2 && isObject(%client = %obj.client))
		{
			commandToClient(%client, 'bottomPrint', "<color:ff0000>Nice Shot! <color:ffffff>" @ %objsKilled @ " kills in one shot!", 5);
		}
	}
	else
	{
		return Parent::onFire(%this, %obj, %slot);
	}
}

function Sniper_RifleSightsImage::onFire(%this,%obj,%slot)
	{
	
	%obj.PlayAudio(2,Sniper_RifleEchoSound);
	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;
	
	if(%this.raycastWeaponRange > 0)
	{
		// Directional Math
		%fvec		= %obj.getForwardVector();
		%fX			= getWord(%fvec,0);
		%fY			= getWord(%fvec,1);
		
		%evec		= %obj.getEyeVector();
		%eX			= getWord(%evec,0);
		%eY			= getWord(%evec,1);
		%eZ			= getWord(%evec,2);
		
		%eXY		= mSqrt((%eX * %eX) + (%eY * %eY));
		%aimVec		= (%fX * %eXY) SPC (%fY * %eXY) SPC %eZ;
		
		// Range
		%range		= %this.raycastWeaponRange * getWord(%obj.getScale(), 2);
		
		if(%range >= 100)
		{
			%rangeRem = %range - 100;
			%range = 100;
		}
		
		// Raycast Parameters
		%start		= %obj.getEyePoint();
		%end[0]		= vectorAdd(%start, vectorScale(%aimVec, %range)); // [0] required for loop
		%targets	= %this.raycastWeaponTargets;
		
		// Raycasting
		%ray		= ContainerRayCast(%start, %end[0], %targets, %obj);
		%col		= getWord(%ray, 0);
		
		if(isObject(%col))
		{
			%pos	= posFromRaycast(%ray);
			%normal	= normalFromRaycast(%ray);
			%end[0]	= %pos;
			%colclass	= %col.getClassName();
			%objsHit++;
			
			%this.onHitObject(%obj, %slot, %col, %pos, %normal, %objsHit);
			
			if(%colclass $= "Player" || %colclass $= "AIPlayer")
			{
				if(%col.getState() $= "Dead")
				{
					%objsKilled++;
				}
			}
		}
		
		if(%rangeRem > 0)
		{
			for(%a = 1; %a <= 10 && %rangeRem > 0; %a++)
			{
				%range		= %rangeRem;
				
				if(%range >= 100)
				{
					%rangeRem = %range - 100;
					%range = 100;
				}
				
				%start[%a]	= %end[%a - 1];
				%end[%a]	= vectorAdd(%start[%a], vectorScale(%aimVec, %range)); 
				
				%ray		= ContainerRayCast(%start[%a], %end[%a], %targets, %obj);
				%col		= getWord(%ray, 0);
				
				if(isObject(%col))
				{
					%pos		= posFromRaycast(%ray);
					%normal		= normalFromRaycast(%ray);
					%end[%a]	= %pos;
					%colclass	= %col.getClassName();
					%objsHit++;
					
					%this.onHitObject(%obj, %slot, %col, %pos, %normal, %objsHit);
					
					if(%colclass $= "Player" || %colclass $= "AIPlayer")
					{
						if(%col.getState() $= "Dead")
						{
							%objsKilled++;
						}
					}
					
					if(%objsHit >= 4)
					{
						break;
					}
				}
			}
		}
		
		if(%objsKilled >= 2 && isObject(%client = %obj.client))
		{
			commandToClient(%client, 'bottomPrint', "<color:ff0000>Nice Shot! <color:ffffff>" @ %objsKilled @ " kills in one shot!", 5);
		}
	}
	else
	{
		return Parent::onFire(%this, %obj, %slot);
	}
}

function Sniper_RifleImageScoped::onHitObject(%this, %obj, %slot, %col, %pos, %normal, %objsHit)
{ 
	if(%this.raycastDirectDamage > 0 && %col.getType() & ($TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType))
	{
		if(miniGameCanDamage(%obj, %col) == 1 && !%col.getDatablock().indestructable)
		{
			if(%this.raycastDirectDamageType)
			{
				%damageType = %this.raycastDirectDamageType;
			}
			else
			{
				%damageType = $DamageType::Direct;
			}
			
			%scale			= %obj.getScale();
			%scaleFactor	= (getWord(%scale, 0) + getWord(%scale, 1) + getWord(%scale, 2)) / 3;
			%damFloat		= mClampF(%this.raycastDirectDamage, -100, 100);
			%directDamage	= (%damFloat * %scaleFactor) / %objsHit;
			
			%col.damage(%obj, %pos, %directDamage, %damageType);
		}
	}
	
	if(isObject(%this.raycastExplosionProjectile))
	{
		%scale			= %obj.getScale();
		%scaleFactor	= ((getWord(%scale, 0) + getWord(%scale, 1) + getWord(%scale, 2)) / 3) / %objsHit;
		
		%p = new Projectile()
		{
			dataBlock		= %this.raycastExplosionProjectile;
			initialPosition	= %pos;
			initialVelocity	= %normal;
			sourceObject	= %obj;
			client			= %obj.client;
			sourceSlot		= 0;
			originPoint		= %pos;
		};
		
		MissionCleanup.add(%p);
		%p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
		%p.explode();
	}
	
	if(isObject(%this.raycastExplosionSound))
	{
		serverplay3d(%this.raycastExplosionSound, %pos);
	}
}

function Sniper_RifleSightsImage::setSniper_RifleReN(%this,%obj,%slot)
{
	%obj.mountImage(Sniper_RifleImage, 0, 0, 0);
	%obj.toolAmmo[%obj.currTool] = 0;
}

function Sniper_RifleImage::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <= 0)
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function Sniper_RifleImage::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
	%obj.AmmoSpent[%obj.currTool] = 0;
	%obj.setImageAmmo(%slot,1);
}
package Sniper_RifleSightsSwitch
{
	function armor::onTrigger(%this, %obj, %triggerNum, %val)
	{
		%client = %obj.client;
		if(%triggerNum == 4 && %obj.isImageMounted(Sniper_RifleImage) && %val && %obj.toolAmmo[%obj.currTool] != 0)
		{
			%newAmmo = %obj.toolAmmo[%obj.currTool];
			%obj.mountImage(Sniper_RifleSightsImage, 0);
			%obj.toolAmmo[%obj.currTool] = %newAmmo;
			%obj.client.setControlCameraFov(30);
		}
		else if(%triggerNum == 4 && %obj.isImageMounted(Sniper_RifleSightsImage) && %val)
		{
			%newAmmo = %obj.toolAmmo[%obj.currTool];
			%obj.mountImage(Sniper_RifleImage, 0);
			%obj.toolAmmo[%obj.currTool] = %newAmmo;
			%obj.client.setControlCameraFov(90);
		}

		Parent::onTrigger(%this, %obj, %triggerNum, %val);
	}
};
activatePackage(Sniper_RifleSightsSwitch);

function Sniper_RifleImage::onMount(%this,%obj,%slot)
{
  
  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function Sniper_RifleImage::onUnMount(%this,%obj,%slot)
{
  
  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
}

function Sniper_RifleSightsImage::onMount(%this,%obj,%slot)
{
  
  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function Sniper_RifleSightsImage::onUnMount(%this,%obj,%slot)
{
  
  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
}